sc::RedundMolecularCoor Class Reference

    The RedundMolecularCoor class provides a redundant set of simple

internal coordinates. More...

`#include <coor.h>`

Inheritance diagram for sc::RedundMolecularCoor:
[legend]
Collaboration diagram for sc::RedundMolecularCoor:
[legend]

## Public Member Functions

| RedundMolecularCoor (Ref< Molecule > &mol)
| RedundMolecularCoor (StateIn &)
| RedundMolecularCoor (const Ref< KeyVal > &)
| The KeyVal constructor.
void | save_data_state (StateOut &)
| Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them. More...
void | form_coordinates (int keep_variable=0)
| Actually form the variable and constant internal coordinates from the simple internal coordinates. More...
void | guess_hessian (RefSymmSCMatrix &hessian)
| Form the approximate hessian.
RefSymmSCMatrix | inverse_hessian (RefSymmSCMatrix &)
| Invert the hessian.
Public Member Functions inherited from sc::IntMolecularCoor
| IntMolecularCoor (StateIn &)
| IntMolecularCoor (Ref< Molecule > &mol)
| IntMolecularCoor (const Ref< KeyVal > &)
| The KeyVal constructor. More...
virtual int | all_to_cartesian (const Ref< Molecule > &, RefSCVector &internal)
| Like to_cartesians(), except all internal coordinates are considered, not just the variable ones. More...
virtual int | all_to_internal (const Ref< Molecule > &, RefSCVector &internal)
| Like to_internal(), except all internal coordinates are considered, not just the variable ones. More...
virtual RefSCDimension | dim ()
| These implement the virtual functions inherited from MolecularCoor. More...
virtual int | to_cartesian (const Ref< Molecule > &, const RefSCVector &internal)
virtual int | to_internal (RefSCVector &internal)
| Fill in the vector ``internal'' with the current internal coordinates. More...
virtual int | to_cartesian (RefSCVector &cartesian, RefSCVector &internal)
| Convert the internal coordinate gradients in ``internal'' to Cartesian coordinates and copy these Cartesian coordinate gradients to ``cartesian''. More...
virtual int | to_internal (RefSCVector &internal, RefSCVector &cartesian)
| Convert the Cartesian coordinate gradients in ``cartesian'' to internal coordinates and copy these internal coordinate gradients to ``internal''. More...
virtual int | to_cartesian (RefSymmSCMatrix &cart, RefSymmSCMatrix &internal)
| Convert the internal coordinate Hessian `internal'' to Cartesian coordinates and copy the result to`cartesian''. More...
virtual int | to_internal (RefSymmSCMatrix &internal, RefSymmSCMatrix &cart)
| Convert the Cartesian coordinate Hessian `cartesian'' to internal coordinates and copy the result to`internal''. More...
virtual void | print (std::ostream &=ExEnv::out0()) const
| Print the coordinate.
virtual void | print_simples (std::ostream &=ExEnv::out0()) const
virtual void | print_variable (std::ostream &=ExEnv::out0()) const
virtual void | print_constant (std::ostream &=ExEnv::out0()) const
int | nconstrained ()
| Returns the number of constrained coordinates.
Public Member Functions inherited from sc::MolecularCoor
| MolecularCoor (Ref< Molecule > &)
| MolecularCoor (StateIn &)
| MolecularCoor (const Ref< KeyVal > &)
| The KeyVal constructor. More...
RefSCDimension | dim_natom3 ()
| Returns a smart reference to an SCDimension equal to the number of atoms in the molecule times 3. More...
Ref< Molecule > | molecule () const
| Returns the molecule.
int | to_cartesian (const RefSCVector &internal)
| Given a set of displaced internal coordinates, update the cartesian coordinates of the Molecule contained herein. More...
virtual Ref< NonlinearTransform > | change_coordinates ()
| When this is called, MoleculeCoor may select a new internal coordinate system and return a transform to it. More...
Ref< SCMatrixKit > | matrixkit () const
Public Member Functions inherited from sc::SavableState
SavableState & | operator= (const SavableState &)
void | save_state (StateOut &)
| Save the state of the object as specified by the StateOut object. More...
void | save_object_state (StateOut &)
| This can be used for saving state when the exact type of the object is known for both the save and the restore. More...
virtual void | save_vbase_state (StateOut &)
| Save the virtual bases for the object. More...
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Additional Inherited Members

Static Public Member Functions inherited from sc::SavableState
static void | save_state (SavableState *s, StateOut &)
static SavableState * | restore_state (StateIn &si)
| Restores objects saved with save_state. More...
static SavableState * | key_restore_state (StateIn &si, const char *keyword)
| Like restore_state, but keyword is used to override values while restoring. More...
static SavableState * | dir_restore_state (StateIn &si, const char *objectname, const char *keyword=0)
Protected Member Functions inherited from sc::IntMolecularCoor
void | form_K_matrix (RefSCDimension &dredundant, RefSCDimension &dfixed, RefSCMatrix &K, int *&is_totally_symmetric)
virtual void | init ()
| This is called by the constructors of classes derived from IntMolecularCoor. More...
virtual void | new_coords ()
| Allocates memory for the SetIntCoor's used to store the simple and internal coordinates. More...
virtual void | read_keyval (const Ref< KeyVal > &)
| Reads the KeyVal input.
Protected Attributes inherited from sc::IntMolecularCoor
Ref< IntCoorGen > | generator_
RefSCDimension | dim_
RefSCDimension | dvc_
Ref< SetIntCoor > | variable_
Ref< SetIntCoor > | constant_
Ref< SetIntCoor > | fixed_
Ref< SetIntCoor > | watched_
Ref< IntCoor > | followed_
Ref< SetIntCoor > | bonds_
Ref< SetIntCoor > | bends_
Ref< SetIntCoor > | tors_
Ref< SetIntCoor > | outs_
Ref< SetIntCoor > | extras_
Ref< SetIntCoor > | all_
int | update_bmat_
int | only_totally_symmetric_
double | symmetry_tolerance_
double | simple_tolerance_
double | coordinate_tolerance_
double | cartesian_tolerance_
double | scale_bonds_
double | scale_bends_
double | scale_tors_
double | scale_outs_
int | nextra_bonds_
int * | extra_bonds_
int | given_fixed_values_
int | decouple_bonds_
int | decouple_bends_
int | max_update_steps_
double | max_update_disp_
int | form_print_simples_
int | form_print_variable_
int | form_print_constant_
int | form_print_molecule_

## Detailed Description

    The RedundMolecularCoor class provides a redundant set of simple

internal coordinates.

## Member Function Documentation

void sc::RedundMolecularCoor::form_coordinates | ( | int | keep_variable = `0` | ) |

virtual

Actually form the variable and constant internal coordinates from the simple internal coordinates.

Implements sc::IntMolecularCoor.

void sc::RedundMolecularCoor::save_data_state | ( | StateOut & |  | ) |

virtual

Save the base classes (with save_data_state) and the members in the same order that the StateIn CTOR initializes them.

This must be implemented by the derived class if the class has data.

Reimplemented from sc::IntMolecularCoor.

The documentation for this class was generated from the following file:

- coor.h